<?php

// ini_set('display_errors',1);

session_start();
date_default_timezone_set('America/Lima');
if($_SESSION["sistema"]!= "1"){ header("location: ../../index.php"); exit();}
require_once ("../../config/Cado.php");

require_once ("cDevolucionproveedor.php");
$oDevolucionproveedor = new cDevolucionproveedor();
require_once("../stock/cStock.php");
$oStock = new cStock();

require_once ("../talonario/cTalonario.php");
$oTalonario= new cTalonario();
require_once("../guiaremision/cGuiaremision.php");
$oGuiaremision = new cGuiaremision();
require_once ("../documento/cDocumento.php");
$oDocumento= new cDocumento();
require_once ("../producto/cCatalogo.php");
$oCatalogo = new cCatalogo();

require_once("../almacen/cAlmacen.php");
$oAlmacen = new cAlmacen();

require_once("../formatos/formato.php");


if($_POST['action']=="relacionar")
{	
		$dts1=$oAlmacen->mostrarAlmCajEmp($_POST['hdd_emp_id']);
		$dt1 = mysqli_fetch_array($dts1);
 		$emp=$dt1['tb_empresa_id'];
 		$punven_id=$dt1['tb_puntoventa_id'];
 		$piso_id=$dt1['tb_piso_id'];
 		$almid = $dt1['tb_almacen_id'];
		mysqli_free_result($dts1);

	$dts1= $oDevolucionproveedor->mostrarDetalles($_POST['hdd_dev_id']);
	while($dt2 = mysqli_fetch_array($dts1))
	{
		
		$cantidad = $dt2['tb_devolucionproveedordetalle_can'];
		$dtscat=$oCatalogo->mostrarUno($dt2['tb_catalogo_id'],$dt2['tb_marca_id']);
		$dtcat = mysqli_fetch_array($dtscat);
			$pre_id	= $dtcat['tb_presentacion_id'];
			$cat_fac = $dtcat['tb_catalogo_fac'];
		mysqli_free_result($dtscat);
		
		$dts=$oStock->stock_por_presentacion($pre_id,$dt2['tb_marca_id'],$almid);
		$dt = mysqli_fetch_array($dts);
			$sto_id		=$dt['tb_stock_id'];
			$sto_num	=$dt['tb_stock_num'];
		mysqli_free_result($dts);
			
		$stock_nuevo = 	$sto_num + $cantidad;
			
		$oStock->modificar($sto_id,$stock_nuevo);	
	}
	
	$oDevolucionproveedor->modificar_campo($_POST['hdd_dev_id'],'est','1');
	$oDevolucionproveedor->modificar_campo($_POST['hdd_dev_id'],'rel',$_POST['hdd_fil_doc_id']);

	$data['dev_msj']='La devolucion se ha resuelto correctamente.';
	echo json_encode($data);
}



if($_POST['action']=="cancelar")
{	
		$dts1=$oAlmacen->mostrarAlmCajEmp($_POST['empid']);
		$dt1 = mysqli_fetch_array($dts1);
 		$emp=$dt1['tb_empresa_id'];
 		$punven_id=$dt1['tb_puntoventa_id'];
 		$piso_id=$dt1['tb_piso_id'];
 		$almid = $dt1['tb_almacen_id'];
		mysqli_free_result($dts1);

	$dts1= $oDevolucionproveedor->mostrarDetalles($_POST['devid']);
	while($dt2 = mysqli_fetch_array($dts1))
	{
		
		$cantidad = $dt2['tb_devolucionproveedordetalle_can'];
		$dtscat=$oCatalogo->mostrarUno($dt2['tb_catalogo_id'],$dt2['tb_marca_id']);
		$dtcat = mysqli_fetch_array($dtscat);
			$pre_id	= $dtcat['tb_presentacion_id'];
			$cat_fac = $dtcat['tb_catalogo_fac'];
		mysqli_free_result($dtscat);
		
		$dts=$oStock->stock_por_presentacion($pre_id,$dt2['tb_marca_id'],$almid);
		$dt = mysqli_fetch_array($dts);
			$sto_id		=$dt['tb_stock_id'];
			$sto_num	=$dt['tb_stock_num'];
		mysqli_free_result($dts);
			
		$stock_nuevo = 	$sto_num + $cantidad;
			
		$oStock->modificar($sto_id,$stock_nuevo);
		
	}

	$oDevolucionproveedor->modificar_campo($_POST['devid'],'est','2');

	$data['dev_msj']='La devolucion se ha cancelado correctamente.';
	echo json_encode($data);
}

if($_POST['action']=="editar")
{	
$oDevolucionproveedor->modificar_campo($_POST['txt_dev_id'],'tranom',$_POST['txt_dev_tranom']);
$oDevolucionproveedor->modificar_campo($_POST['txt_dev_id'],'tracom',$_POST['txt_dev_tracom']);
$oDevolucionproveedor->modificar_campo($_POST['txt_dev_id'],'obs1',$_POST['txt_dev_obs1']);

$data['dev_msj']='Modificado correctamente.';
echo json_encode($data);
		
}

if($_POST['action']=="insertar")
{	

		$dts= $oDocumento->mostrarUno(23);
		$dt = mysqli_fetch_array($dts);
		$doc_nom=$dt['tb_documento_nom'];
		$doc_abr=$dt['tb_documento_abr'];
		mysqli_free_result($dts);
	


		if($doc_abr=='T'){
		$ser = 'T00'.$_SESSION['usuario_ser'];
		}else if($doc_abr=='F'){
		$ser = 'F00'.$_SESSION['usuario_ser'];
		}else if($doc_abr=='B'){
		$ser = 'B00'.$_SESSION['usuario_ser'];
		}else if($doc_abr=='GR'){
		$ser = 'GR00'.$_SESSION['usuario_ser'];
		}else if($doc_abr=='NC'){
		$ser = 'NC00'.$_SESSION['usuario_ser'];
		}else if($doc_abr=='P'){
		$ser = 'P00'.$_SESSION['usuario_ser'];
		}
		
		$dts= $oTalonario->correlativo($_SESSION['puntoventa_id'],'23',$ser);
		$dt = mysqli_fetch_array($dts);
			$tal_id=$dt['tb_talonario_id'];
			$tal_ser=$dt['tb_talonario_ser'];
			$tal_fin=$dt['tb_talonario_fin'];
			$tal_num=$dt['tb_talonario_num'];
		mysqli_free_result($dts);
	
		$numero=$tal_num;
		$largo=strlen($tal_fin);
		$numero=str_pad($numero,$largo, "0", STR_PAD_LEFT);
		$numdoc=$tal_ser.'-'.$numero;
	

		$dts1=$oAlmacen->mostrarAlmCajEmp($_POST['hdd_emp_id']);
		$dt1 = mysqli_fetch_array($dts1);
 		$emp=$dt1['tb_empresa_id'];
 		$punven_id=$dt1['tb_puntoventa_id'];
 		$piso_id=$dt1['tb_piso_id'];
 		$almid = $dt1['tb_almacen_id'];
		mysqli_free_result($dts1);

		$oDevolucionproveedor->insertar(
		$_SESSION['usuario_id'],
		$_POST['txt_dev_fec'],
		$_POST['txt_dev_tranom'],
		$_POST['txt_dev_tracom'],
		$_POST['txt_dev_obs1'],
		$_POST['txt_dev_comid'],
		$_POST['txt_dev_tot']
		);
	
		$dts=$oDevolucionproveedor->ultimoInsert();
 		$dt = mysqli_fetch_array($dts);
 		$dev_id=$dt['id'];
 		mysqli_free_result($dts);
		
		
		$rs=$oGuiaremision->insertar(
			fecha_mysql($_POST['txt_dev_fec']),
			'23',
			$numdoc,
			'2',
			$_POST['hdd_prov_id'],
			$_POST['hdd_prov_doc'],
			$_POST['hdd_prov_nom'],
			'',
			'',
			'',
			'',
			$_POST['hdd_venta_id'],
			$numdoc_rel,
			'13',
			'',
			'',
			$_POST['txt_ori_gui'],
			$_POST['txt_des_gui'],
			'',
			$_SESSION['usuario_id'],
			$_SESSION['puntoventa_id'],
			$_POST['txt_ate_guia'],
			'',
			'',
			fecha_mysql($_POST['txt_dev_fec']),
			'0',
			''
		);

		//ultima venta
		$dts=$oGuiaremision->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$guiaid=$dt['id'];
		mysqli_free_result($dts);
		
		
		$estado='1';
		if($tal_num==$tal_fin)
		{
			$estado='2';
		}
		$numero=$tal_num+1;
		$rs3 = $oTalonario->actualizar_correlativo($tal_id, $numero, $estado);
		
		
	
		foreach($_SESSION['devol_car'] as $indice=>$cantidad)
		{
		
		$oDevolucionproveedor->insertardetalle(
		$dev_id,
		$_SESSION['devol_catid'][$indice],
		$_SESSION['devol_marid'][$indice],
		$cantidad,
		$_SESSION['devol_valuni'][$indice]
		);
		
		
		$dtscat=$oCatalogo->mostrarUno($_SESSION['devol_catid'][$indice],$_SESSION['devol_marid'][$indice]);
		$dtcat = mysqli_fetch_array($dtscat);
			$pre_id	= $dtcat['tb_presentacion_id'];
			$cat_fac = $dtcat['tb_catalogo_fac'];
		mysqli_free_result($dtscat);
		
		if($cantidad>0){
			
			$oGuiaremision->insertar_detalle(
				$cantidad,
				$_SESSION['devol_catid'][$indice],
				$_SESSION['devol_marid'][$indice],
				$pes,
				$pre_uni,
				$guiaid
			);
		}
		
		
		
		
		$dts=$oStock->stock_por_presentacion($pre_id,$_SESSION['devol_marid'][$indice],$almid);
		$dt = mysqli_fetch_array($dts);
			$sto_id		=$dt['tb_stock_id'];
			$sto_num	=$dt['tb_stock_num'];
		mysqli_free_result($dts);
			
		$stock_nuevo = 	$sto_num - $cantidad;
			
		$oStock->modificar($sto_id,$stock_nuevo);
		
		}
	
		$data['guia_id']=$guiaid;
		$data['dev_msj']='Registrado correctamente.';
		echo json_encode($data);
}

?>







